### Hierarchy

- Param

## Index

### Constructors

- constructor

### Properties

- _defaultValueCache
- array
- config
- dynamic
- id
- inherit
- isOptional
- location
- raw
- replace
- squash
- type

### Methods

- isDefaultValue
- isSearch
- toString
- validates
- value
- changed
- equals
- validates
- values

## Constructors

- new Param(id: string, type: ParamType, config: ParamDeclaration, location: DefType.PATH | DefType.SEARCH | DefType.CONFIG, urlMatcherFactory: UrlMatcherFactory): Param

- #### Parameters

  - ##### id string

  - ##### type ParamType

  - ##### config ParamDeclaration

  - ##### location DefType.PATH | DefType.SEARCH | DefType.CONFIG

  - ##### urlMatcherFactory UrlMatcherFactory

  #### Returns Param

  - Defined in params/param.ts:140

## Properties

_defaultValueCache: object

Cache the default value if it is a static value

Cache the default value if it is a static value

#### Type declaration

- ##### defaultValue: any

- Defined in params/param.ts:97

array: boolean

- Defined in params/param.ts:94

config: any

- Defined in params/param.ts:95

dynamic: boolean

- Defined in params/param.ts:89

id: string

- Defined in params/param.ts:85

inherit: boolean

- Defined in params/param.ts:93

isOptional: boolean

- Defined in params/param.ts:88

location: DefType.PATH | DefType.SEARCH | DefType.CONFIG

- Defined in params/param.ts:87

raw: boolean

- Defined in params/param.ts:90

replace: [object]

- Defined in params/param.ts:92

squash: string | true | false

- Defined in params/param.ts:91

type: ParamType

- Defined in params/param.ts:86

## Methods

- isDefaultValue(value: any): boolean

- #### Parameters

  - ##### value any

  #### Returns boolean

  - Defined in params/param.ts:164

- isSearch(): boolean

- #### Returns boolean

  - Defined in params/param.ts:205

- toString(): string

- #### Returns string

  - Defined in params/param.ts:222

- validates(value: any): boolean

- #### Parameters

  - ##### value any

  #### Returns boolean

  - Defined in params/param.ts:209

- value(value?: any): any

- [Internal] Gets the decoded representation of a value if the value is defined, otherwise, returns the default value, which may be the result of an injectable function.

- [Internal] Gets the decoded representation of a value if the value is defined, otherwise, returns the default value, which may be the result of an injectable function.

  #### Parameters

  - ##### value: Optional any

  #### Returns any

  - Defined in params/param.ts:172

- changed(params: Param[], values1?: RawParams, values2?: RawParams): Param[]

- Finds Param objects which have different param values

- Finds Param objects which have different param values

  Filters a list of Param objects to only those whose parameter values differ in two param value objects

  #### Parameters

  - ##### params Param[]

  - ##### values1: Default value RawParams = {}

  - ##### values2: Default value RawParams = {}

  #### Returns Param[]

  :

  any Param objects whose values were different between values1 and values2

  - Defined in params/param.ts:120

- equals(params: Param[], values1?: object, values2?: object): boolean

- Checks if two param value objects are equal (for a set of Param objects)

- Checks if two param value objects are equal (for a set of Param objects)

  #### Parameters

  - ##### params Param[]

    :

    The list of Param objects to check

  - ##### values1: Default value object = {}

    :

    The first set of param values

  - ##### values2: Default value object = {}

    :

    The second set of param values

  #### Returns boolean

  :

  true if the param values in values1 and values2 are equal

  - Defined in params/param.ts:133

- validates(params: Param[], values?: RawParams): boolean

- Returns true if a the parameter values are valid, according to the Param definitions

- Returns true if a the parameter values are valid, according to the Param definitions

  #### Parameters

  - ##### params Param[]

  - ##### values: Default value RawParams = {}

  #### Returns boolean

  - Defined in params/param.ts:138

- values(params: Param[], values?: RawParams): RawParams

- #### Parameters

  - ##### params Param[]

  - ##### values: Default value RawParams = {}

  #### Returns RawParams

  - Defined in params/param.ts:101

Generated using TypeDoc